(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("codemirror"), require("codemirror/addon/runmode/runmode"));
	else if(typeof define === 'function' && define.amd)
		define("abap", ["codemirror", "codemirror/addon/runmode/runmode"], factory);
	else if(typeof exports === 'object')
		exports["abap"] = factory(require("codemirror"), require("codemirror/addon/runmode/runmode"));
	else
		root["abap"] = factory(root["codemirror"], root["codemirror/addon/runmode/runmode"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__1__, __WEBPACK_EXTERNAL_MODULE__2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initAbapMode = exports.abapMode = void 0;
var codemirror_1 = __importDefault(__webpack_require__(1));
__webpack_require__(2);
var constants_1 = __webpack_require__(3);
exports.abapMode = function () {
    var composeKeywords = function (words) {
        return words.reduce(function (result, word) {
            var _a;
            return (__assign(__assign({}, result), (_a = {}, _a[word] = true, _a)));
        }, {});
    };
    var keywords = composeKeywords(constants_1.KEYWORDS);
    var checkMatch = function (stream, separators, callback) {
        var next = stream.next();
        var back = 0;
        while (true) {
            if (!next) {
                break;
            }
            else if (separators.includes(next)) {
                stream.backUp(1);
                break;
            }
            else {
                back++;
            }
            next = stream.next();
        }
        var toCheck = stream.current().toUpperCase();
        var match = callback(toCheck);
        if (match === false) {
            stream.backUp(back);
        }
        return match;
    };
    var isKeyword = function (stream) {
        var checkKeyword = function (input) {
            return keywords.propertyIsEnumerable(input);
        };
        var KEYWORD_SEPARATORS = '(.,: ';
        return checkMatch(stream, KEYWORD_SEPARATORS, checkKeyword);
    };
    var isOperator = function (stream) {
        var checkOperator = function (input) {
            return constants_1.OPERATORS.includes(input);
        };
        return checkMatch(stream, ' ', checkOperator);
    };
    return {
        token: function (stream, state) {
            if (stream.eatSpace()) {
                return null;
            }
            if (isKeyword(stream)) {
                return constants_1.KEYWORD;
            }
            else if (stream.match(/^\d+( |\.|$)/, false)) {
                stream.match(/^\d+/);
                return constants_1.NUMBER;
            }
            else if (stream.match(/^##\w+/)) {
                // pragmas
                return constants_1.COMMENT;
            }
            var char = stream.next();
            var peek = stream.peek();
            if (peek === undefined) {
                peek = '';
            }
            if ((char === '*' && stream.column() === 0) || char === '"') {
                stream.skipToEnd();
                return constants_1.COMMENT;
            }
            else if (isOperator(stream)) {
                return constants_1.OPERATOR;
            }
            else if (char === "'") {
                var next = void 0;
                next = '';
                while (next !== undefined) {
                    if (next === "'") {
                        state.mode = false;
                        break;
                    }
                    next = stream.next();
                }
                return constants_1.STRING;
            }
            else if (char === '|') {
                var next = void 0;
                next = '';
                while (next !== undefined) {
                    if (next === '|') {
                        state.mode = false;
                        break;
                    }
                    next = stream.next();
                }
                return constants_1.STRING;
            }
            else {
                stream.eatWhile(/(\w|<|>)/);
                return null;
            }
        },
        startState: function () { return ({
            mode: false,
        }); },
    };
};
exports.initAbapMode = function (codemirror) {
    codemirror.defineMode('abap', exports.abapMode);
    codemirror.defineMIME('text/abap', 'abap');
    var mimeType = {
        name: 'ABAP',
        mime: 'text/abap',
        mode: 'abap',
        ext: ['abap'],
    };
    /* istanbul ignore next */
    if (codemirror.modeInfo && codemirror.modeInfo.push) {
        codemirror.modeInfo.push(mimeType);
    }
    else if (!codemirror.modeInfo) {
        codemirror.modeInfo = [mimeType];
    }
    return codemirror;
};
// automatically initialize the mode
/* istanbul ignore next */
(function (mod) {
    if (true)
        // CommonJS
        try {
            mod(__webpack_require__(!(function webpackMissingModule() { var e = new Error("Cannot find module '../../codemirror/lib/codemirror'"); e.code = 'MODULE_NOT_FOUND'; throw e; }())));
        }
        catch (err) {
            // tslint:disable-next-line:no-console
            console.log('CodeMirror module not found.');
        }
    // @ts-ignore
    else {}
})(function (instance) { return exports.initAbapMode(instance); });


/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__1__;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__2__;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.STRING = exports.OPERATOR = exports.NUMBER = exports.KEYWORD = exports.COMMENT = exports.OPERATORS = exports.KEYWORDS = void 0;
var KEYWORD_WORDS = 'ABSTRACT ADD ADD-CORRESPONDING ADJACENT ALIAS ALIASES ALL AND APPEND APPENDING AS ASCENDING ASSERT ASSIGN ASSIGNED ASSIGNING ASSOCIATION AT AUTHORITY-CHECK BACK BEGIN BINARY BLOCK BOUND BREAK-POINT BY BYTE CALL CASE CAST CATCH CHANGING CHARACTER CHECK CLASS CLASS-DATA CLASS-METHOD CLASS-METHODS CLASS-POOL CLEAR CLOSE CNT COLLECT COMMIT COMMUNICATION COMPONENT COMPUTE CONCATENATE COND CONDENSE CONSTANTS CONTINUE CONTROLS CONV CONVERT CORRESPONDING COUNT CREATE CURRENCY DATA DEFAULT DEFERRED DEFINE DEFINITION DELETE DELETING DESCENDING DESCRIBE DESTINATION DETAIL DISPLAY DISPLAY-MODE DIVIDE DIVIDE-CORRESPONDING DO DUPLICATES DURATION EDITOR-CALL ELSE ELSEIF EMPTY END END-OF-DEFINITION END-OF-PAGE END-OF-SELECTION END-TEST-INJECTION END-TEST-SEAM ENDAT ENDCASE ENDCLASS ENDDO ENDEXEC ENDFORM ENDFUNCTION ENDIF ENDING ENDINTERFACE ENDLOOP ENDMETHOD ENDMODULE ENDON ENDPROVIDE ENDSELECT ENDTRY ENDWHILE ENUM EQ EVENT EVENTS EXCEPTION EXCEPTIONS EXEC EXIT EXIT-COMMAND EXPORT EXPORTING EXTRACT FETCH FIELD FIELD-GROUPS FIELD-SYMBOL FIELD-SYMBOLS FIELDS FINAL FIND FIRST FOR FORM FORMAT FOUND FRAME FREE FRIENDS FROM FUNCTION FUNCTION-POOL GE GENERATE GET HANDLE HARMLESS HASHED HEADER HIDE ID IF IMPLEMENTATION IMPLEMENTED IMPORT IMPORTING IN INCLUDE INDEX INFOTYPES INHERITING INIT INITIAL INITIALIZATION INPUT INSERT INSTANCE INTERFACE INTERFACE-POOL INTERFACES INTO IS KEY LEADING LEAVE LEFT LEFT-JUSTIFIED LENGTH LEVEL LIKE LINE LINE-COUNT LINE-SIZE LOAD LOCAL LOG-POINT LOOP LOWER MATCH MATCHCODE MESH MESSAGE MESSAGE-ID METHOD METHODS MODIFY MODULE MOVE MOVE-CORRESPONDING MULTIPLY MULTIPLY-CORRESPONDING NEW NEW-LINE NEW-PAGE NEW-SECTION NEXT NO NO-GAP NO-GAPS NO-SIGN NO-ZERO NON-UNIQUE NOT NUMBER OBJECT OBLIGATORY OCCURRENCE OCCURRENCES OCCURS OF OFFSET ON OPTIONAL OPTIONS OTHERS OUTPUT OVERLAY PACK PARAMETERS PARTIALLY PERFORM PLACES POSITION PRINT-CONTROL PRIVATE PROGRAM PROTECTED PROVIDE PUBLIC PUT RADIOBUTTON RAISE RAISING RANGE RANGES READ READ-ONLY RECEIVE RECEIVING REDEFINITION REDUCE REF REFERENCE REFRESH REGEX REJECT REPLACE REPORT REQUESTED RESERVE RESTORE RESULT RESULTS RETURN RETURNING RIGHT-JUSTIFIED RISK ROLLBACK RP-PROVIDE-FROM-LAST RUN SCAN SCREEN SCROLL SEARCH SECONDARY SECTION SELECT SELECT-OPTIONS SELECTION-SCREEN SEPARATED SET SHIFT SHORT SINGLE SKIP SORT SORTED SOURCE SPLIT STAMP STANDARD START-OF-SELECTION STARTING STATICS STEP STOP STRUCTURE SUBKEY SUBMATCHES SUBMIT SUBTRACT SUBTRACT-CORRESPONDING SUM SUMMARY SUPPLIED SUPPRESS SWITCH SYNTAX-CHECK SYNTAX-TRACE SYSTEM-CALL TABLE TABLES TASK TEST-INJECTION TEST-SEAM TESTING THEN TIME TIMES TITLE TITLEBAR TO TOP-OF-PAGE TRAILING TRANSFER TRANSFORMATION TRANSLATE TRANSPORTING TRY TYPE TYPE-POOL TYPE-POOLS TYPES ULINE UNASSIGN UNIQUE UNPACK UPDATE UPPER USING VALUE WHEN WHERE WHILE WINDOW WITH WORK WRITE';
var OPERATORS_SYMBOLS = '?= = > <> < <= >= + - * ** / & &&';
var OPERATOR_WORDS = 'EQ NE LT GT GE CS CP NP CO CN DIV MOD BIT-AND BIT-OR BIT-XOR BIT-NOT NOT OR AND XOR BETWEEN EQUIV BYTE-CO, BYTE-CN, BYTE-CA BYTE-NA BYTE-CS BYTE-NS';
exports.KEYWORDS = KEYWORD_WORDS.split(' ');
exports.OPERATORS = OPERATORS_SYMBOLS.concat(OPERATOR_WORDS, ' ').split(' ');
exports.COMMENT = 'comment';
exports.KEYWORD = 'keyword';
exports.NUMBER = 'number';
exports.OPERATOR = 'operator';
exports.STRING = 'string';


/***/ })
/******/ ]);
});
//# sourceMappingURL=abap.js.map